#define	_CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAX_PATH_LEN	4096
#define	MAX_LAYOUT_LEN	32
char	fname[MAX_PATH_LEN];				// ̓t@C
char	str_layout[MAX_LAYOUT_LEN];			// CAEg
unsigned char uc;
int		ct, rec_max, endian;
FILE	*fpr;

// vg^Cv
int layout_str_check(char*);				// \CAEgitH[}bgj`FbN
int dump(int);								// _v

int main(int argc, char *argv[])
{
	int		idx;
	errno_t	err;

	if (argc < 4) {
		printf("\CAEgitH[}bgjw_v\n");
		printf ("g:DumpStrLayout [̓t@C] \n");
		printf ("                     [oCgI[_[F-L or -B] \n");
		printf ("                     [CAEgij]\n");
		printf ("Ps̃CAEgitH[}bgj𐔎Ŏw肵AAhXȂŃ_v܂\n");
		printf ("CAEgij̐\n");
		printf ("  1 - 1oCg\n");
		printf ("  2 - 2oCg\n");
		printf ("  4 - 4oCg\n");
		printf ("  8 - 8oCg\n");
		printf ("[]\n");
		printf ("C:\\>DumpStrLayout TEST.bin -B 112444\n");
		exit (0);
	}

	// GfBA`FbN
	if (strcmp(argv[2], "-l") == 0 || strcmp(argv[2], "-L") == 0) {
		endian = 0;
	} else if (strcmp(argv[2], "-b") == 0 || strcmp(argv[2], "-B") == 0) {
		endian = 1;
	} else {
		printf("GfBA -l  -L  -b  -B  w肵ĉ\n");
		exit (1);
	}

	// \CAEgitH[}bgj񐔃`FbN
	if (strlen(argv[3]) > MAX_LAYOUT_LEN-2) {
		printf("\CAEgitH[}bgj%dȉŎw肵ĉ\n", MAX_LAYOUT_LEN-2);
		exit (1);
	}

	strncpy(str_layout, argv[3], sizeof(str_layout));

	// \CAEgitH[}bgj`FbN
	if (layout_str_check(str_layout)) {
		printf("\CAEgitH[}bgj [1 or 2 or 4 or 8] Ŏw肵ĉ\n");
		exit (1);
	}

	// t@CZbg
	strncpy(fname, argv[1], sizeof(fname));
	fname[MAX_PATH_LEN-1] = 0;				// K[h

	fpr = NULL;

	// t@CI[v
	err = fopen_s (&fpr, fname, "rb");
	if (err != 0) {
		printf( "t@CI[vG[\n" );
		printf(fname);
		printf("\n");
		exit (1);
	}

	ct  = 0;							// JE^
	idx = 0;							// CfbNX

	// Jn
	while (1) {
		uc = str_layout[idx++];
		if (uc == 0) {
			idx = 0;
			printf("\n");
			continue;
		}
		if (!dump((int)(uc - 0x30))) {
			break;
		}
	}

	// t@CN[Y
	if (fpr != NULL) {
		fclose(fpr);
	}

	exit (0);
}

// _v
int dump(int isize)
{
	int	i, j, iRet;
	unsigned char num_buf[8];
	memset(num_buf, 0, sizeof(num_buf));
	iRet = 1;
	for ( i = 0 ; i < isize ; i++ ) {
		j = fgetc(fpr);
		if (j == EOF) {
			iRet = 0;
			if (i == 0) {
				return iRet;
			}
			break;
		}
		num_buf[i] = (unsigned char)j;
	}
	if (endian == 0) {
		// rbOGfBA
		for ( i = 0 ; i < isize ; i++ ) {
			printf("%02X", (int)num_buf[isize-i-1]);
		}

	} else {
		// gGfBA
		for ( i = 0 ; i < isize ; i++ ) {
			printf("%02X", (int)num_buf[i]);
		}
	}
	printf(" ");
	return iRet;
}

// \CAEgitH[}bgj`FbN
int layout_str_check(char* str)
{
	int	i, len, iRet;
	unsigned char uc;
	len = (int)strlen(str);
	iRet = 0;
	for ( i = 0 ; i < len ; i++ ) {
		uc = str[i];
		if ( !(uc == '1' || uc == '2' || uc == '4' || uc == '8') ) {
			iRet = 1;
			break;
		}
	}
	return iRet;
}
